// charsetdetective.cpp -- a commandline program that uses libuniversalchardet -- by Eugene Reimer 2009-08;
//
// Copyright  2009 Eugene Reimer;  can be used, modified, copied, and distributed or sold under the terms of either the LGPL or the GPL (your choice);
// see http://www.gnu.org/licenses for the details of these terms.

#include "universalchardet.h"		//was charguess.h in v1.01
#include <string.h>
#include <stdio.h>
#define  MAXFILESIZE  10*1024*1024	//10MB seems a reasonable tradeoff between speed and accuracy?

char Test00[]= {'h','e','l','l','o', 0xa7, 0};
char Test01[]= {'h','e','l','l','o', 0xc2,0xa7, 0};
char Test02[]= {'h','e','l','l','o', 0xc3,0xa2, 0xc2,0xa7, 0};
char Test03[]= {'h','e','l','l','o', 0xc2,0xa0, 0xc3,0xb7, 0xc3,0xb7, 0xc2,0xa0, 't','h','e','r','e', 0};

int main(int argc, char**argv){
   nsUniversalDetector det;
   const char* res;
   //--unyank the following to try the builtin testcases:
   //const char* Test[] = {Test00,Test01,Test02,Test03};  int i;
   //for(i=0; i<=3; ++i){  
   //   det.HandleData(Test[i], strlen(Test[i]));
   //   det.DataEnd();
   //   res = det.GetCharset();  if(!res) res="unknown";
   //   printf("Test%02X: %s\n", i,res);
   //   det.Reset();
   //}
   for(; argc>=2; --argc,++argv){
      FILE* fd;  char buf[MAXFILESIZE];  int len;
      fd=fopen(argv[1],"r");  if(fd==NULL) {printf("charsetguess: can't open %s\n",argv[1]);  continue;}
      len= fread(buf, 1, MAXFILESIZE, fd);  fclose(fd);
      det.HandleData(buf, len);
      det.DataEnd();
      res = det.GetCharset();  if(!res) res="unknown";
      printf("%s: %s\n", argv[1],res);
      det.Reset();
   }
}
